<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPasswordQuestion ArrayType
 * @subpackage Arrays
 */
class ArrayOfPasswordQuestion extends AbstractStructArrayBase
{
    /**
     * The PasswordQuestion
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\PasswordQuestion[]
     */
    public $PasswordQuestion;
    /**
     * Constructor method for ArrayOfPasswordQuestion
     * @uses ArrayOfPasswordQuestion::setPasswordQuestion()
     * @param \CustomerManagement\StructType\PasswordQuestion[] $passwordQuestion
     */
    public function __construct(array $passwordQuestion = array())
    {
        $this
            ->setPasswordQuestion($passwordQuestion);
    }
    /**
     * Get PasswordQuestion value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\PasswordQuestion[]|null
     */
    public function getPasswordQuestion()
    {
        return isset($this->PasswordQuestion) ? $this->PasswordQuestion : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPasswordQuestion method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPasswordQuestion method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePasswordQuestionForArrayConstraintsFromSetPasswordQuestion(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPasswordQuestionPasswordQuestionItem) {
            // validation for constraint: itemType
            if (!$arrayOfPasswordQuestionPasswordQuestionItem instanceof \CustomerManagement\StructType\PasswordQuestion) {
                $invalidValues[] = is_object($arrayOfPasswordQuestionPasswordQuestionItem) ? get_class($arrayOfPasswordQuestionPasswordQuestionItem) : sprintf('%s(%s)', gettype($arrayOfPasswordQuestionPasswordQuestionItem), var_export($arrayOfPasswordQuestionPasswordQuestionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PasswordQuestion property can only contain items of type \CustomerManagement\StructType\PasswordQuestion, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PasswordQuestion value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\PasswordQuestion[] $passwordQuestion
     * @return \CustomerManagement\ArrayType\ArrayOfPasswordQuestion
     */
    public function setPasswordQuestion(array $passwordQuestion = array())
    {
        // validation for constraint: array
        if ('' !== ($passwordQuestionArrayErrorMessage = self::validatePasswordQuestionForArrayConstraintsFromSetPasswordQuestion($passwordQuestion))) {
            throw new \InvalidArgumentException($passwordQuestionArrayErrorMessage, __LINE__);
        }
        if (is_null($passwordQuestion) || (is_array($passwordQuestion) && empty($passwordQuestion))) {
            unset($this->PasswordQuestion);
        } else {
            $this->PasswordQuestion = $passwordQuestion;
        }
        return $this;
    }
    /**
     * Add item to PasswordQuestion value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\PasswordQuestion $item
     * @return \CustomerManagement\ArrayType\ArrayOfPasswordQuestion
     */
    public function addToPasswordQuestion(\CustomerManagement\StructType\PasswordQuestion $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\PasswordQuestion) {
            throw new \InvalidArgumentException(sprintf('The PasswordQuestion property can only contain items of type \CustomerManagement\StructType\PasswordQuestion, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PasswordQuestion[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\PasswordQuestion|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\PasswordQuestion|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\PasswordQuestion|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\PasswordQuestion|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\PasswordQuestion|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PasswordQuestion
     */
    public function getAttributeName()
    {
        return 'PasswordQuestion';
    }
}
